
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>zookeeper原理解析-数据存储 / 憋错料</title>

    <meta name="description" content="zookeeper原理解析-数据存储 Zookeeper内存结构 Zookeeper是怎么存储数据的,什么机制保证集群中数据是一致性,在网络异常,当机以及停电等异常情况下恢复数据的,我们知道数据库给我们提供了这些功能,其实zookeeper也实现了类似数据库的功能. 1.      Zookeeper内存结构 Zookeeper数据在内存中的结构类似于linux的目录结构 DataTree代表这个目录结构, DataNode代表一个节点 DataTree: 默认初始化三目录 1)&quot;&quot; 2) &quot;/zook ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">zookeeper原理解析-数据存储</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<h2><strong>Zookeeper内存结构</strong></h2>
<p>Zookeeper是怎么存储数据的，什么机制保证集群中数据是一致性，在网络异常，当机以及停电等异常情况下恢复数据的，我们知道<a href="http://lib.csdn.net/base/mysql" rel="external nofollow noreferrer">数据库</a>给我们提供了这些功能，其实zookeeper也实现了类似数据库的功能。</p>
<p>1.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Zookeeper内存结构</p>
<p>Zookeeper数据在内存中的结构类似于linux的目录结构</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTA1MTExOTI2MzE2OTU/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2Y1hWb2IyNW5kMlZwWDNwb1lXNXhhWFU9L2ZvbnQvNWE2TDVMMlQvZm9udHNpemUvNDAwL2ZpbGwvSTBKQlFrRkNNQT09L2Rpc3NvbHZlLzcwL2dyYXZpdHkvQ2VudGVy.jpg"></p>
<pre>DataTree代表这个目录结构， DataNode代表一个节点
         DataTree:
                   默认初始化三目录
                  1）""
          2) "/zookeeper"
         3) "/zookeeper/quota"
         DataNode
                   表示一个节点
                 1） 存储了父节点的引用
                 2） 节点的权限信息
                 3） 子节点路径集合</pre>
<p><strong>Snapshot</strong></p>
<p>Snapshot是datatree在内存中某一时刻的影像，zookeeper有一定的机制会定时生成datatree的snapshot。FileSnap实现了SnapShot接口负责将数据写入文件中，下面我们来看看snap相关内容。</p>
<p>2.1 snapshot文件格式</p>
<p><strong>&nbsp;&nbsp; Snapshot是以二进制形式存在在文件的，我们用ue打开一个新的snapshot文件<br /></strong></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTA1MTExOTMxMTUyMjY/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2Y1hWb2IyNW5kMlZwWDNwb1lXNXhhWFU9L2ZvbnQvNWE2TDVMMlQvZm9udHNpemUvNDAwL2ZpbGwvSTBKQlFrRkNNQT09L2Rpc3NvbHZlLzcwL2dyYXZpdHkvQ2VudGVy.jpg"></p>
<p>Snapshot文件的中数据大体可以分为两部分header和body。</p>
<p>Header数据格式:</p>
<pre>FileHeader{
   int magic  //魔数   常量ZKSN  代表zookeeper snapshot文件
   int  version  //版本  常量 2
   long   dbid   //dbid  常量 -1
}</pre>
<p>这里很奇怪 version和dbid都是常量，那还有什么意思，也许是保留字段为后续版本使用。</p>
<p>由头部字段可以计算出头部信息占用 4 + 4 + 8 =16bit的固定长度</p>
<p>5A 4B 53 4E 就是魔术ZKSN</p>
<p>00 00 00 02 就是dbid号2</p>
<p><strong> FF FF FF FF FF FF FF FF就是十六进制的-1</strong></p>
<pre>public voidserialize(OutputArchive oa, String tag) throws IOException {
        scount = 0;
        serializeList(longKeyMap, oa);
        serializeNode(oa, newStringBuilder(""));
        if (root != null) {
            oa.writeString("/","path");
        }
    }

2.1)序列化longKeyMap是存储在datatree中的acl权限集合
           readInt("map") //acl的映射个数？
        while (map &gt; 0) {
            readLong("long") //这个long值longKeyMap的key，作用？是这一组acl的key
         readInt（"acls"）
         while (acls) {
              readInt("perms")
           readString("scheme")
           readString("id")
           }
     }
2.2)存储datatree中数据节点
        readString("path")//第一个datanode ""
    while(!path.equals("/")) {   //  "/"代表路径结束
           readRecord(node, "node")包括：
           readBuffer("data")
           readLong("acl")
           deserialize(archive,"statpersisted") 状态存储包括:
                          readLong("czxid")  //createNode时事务号
                            readLong("mzxid")  //createNode时与Czxid同,setData时的事务号
                            readLong("ctime")  // 创建节点时间
                            readLong("mtime")  //createNode时与ctime相同，setData时间
                            readInt("version")  //createNode版本为0，setData的数据版本号
                            readInt("cversion") //createNode版本为0，增加/删除子节点时父节点+1
                            readInt("aversion") //createNode版本为0，setACL时节点的版本号
                            readLong("ephemeralOwner") // 临时节点表示sessionid,非临时节点这个值为0
                            readLong("pzxid")  //createNode时与Czxid同,增加/删除子节点时为子节点事务号
        readString("path") //读取下一个路径
  }
3）  文件尾部校验数据
00 00 00 01 2F  snapshot文件结尾5位数据用来校验snapshot文件是否有效
   00 00 00 01一个int的数值就是数字1，代表后面1一个字符数据
   2F 就是snapshot的结束符/</pre>
<p>Body数据格式：</p>
<p>Snapshot文件中头部信息之后，紧接着就是body部分的信息，body数据大小是动态不是固定。</p>
<p>1）&nbsp;Map&lt;Long, Integer&gt; sessionWithTimeoutbody信息前面部分存储的是内存中活着的session以及session的超时时间</p>
<p>oa.writeInt(sessSnap.size(),"count");</p>
<p>for (Entry&lt;Long, Integer&gt; entry :sessSnap.entrySet()) {</p>
<p>oa.writeLong(entry.getKey().longValue(), "id");</p>
<p>oa.writeInt(entry.getValue().intValue(),"timeout");</p>
<p>}</p>
<p>由上面序列到文件代码可以看出先写入一个int类型字段用来存储sessionWithTimeout的个数，然后在遍历集合以一个long一个int的形式写入</p>
<p>2）&nbsp;紧接着就是对datatree序列化到文件了</p>
<p>我们看下datatree的序列化方法</p>
<p><strong><br />
4）Snapshot序列化<br /></strong></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTA1MTExOTMyMTkyNjE/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2Y1hWb2IyNW5kMlZwWDNwb1lXNXhhWFU9L2ZvbnQvNWE2TDVMMlQvZm9udHNpemUvNDAwL2ZpbGwvSTBKQlFrRkNNQT09L2Rpc3NvbHZlLzcwL2dyYXZpdHkvQ2VudGVy.jpg"></p>
<p>5）Snapshot反序列化</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTA1MTExOTM1MjgyODk/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2Y1hWb2IyNW5kMlZwWDNwb1lXNXhhWFU9L2ZvbnQvNWE2TDVMMlQvZm9udHNpemUvNDAwL2ZpbGwvSTBKQlFrRkNNQT09L2Rpc3NvbHZlLzcwL2dyYXZpdHkvQ2VudGVy.jpg"></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 08:54:22 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/%e7%94%9f%e6%88%90/" title="生成">生成</a>, <a href="https://www.biecuoliao.com/tag/%e6%95%b0%e6%8d%ae%e5%ba%93/" title="数据库">数据库</a>, <a href="https://www.biecuoliao.com/tag/hive/" title="hive">hive</a>, <a href="https://www.biecuoliao.com/tag/%e5%a4%a7%e5%b0%8f/" title="大小">大小</a>, <a href="https://www.biecuoliao.com/tag/%e6%98%a0%e5%b0%84/" title="映射">映射</a>, <a href="https://www.biecuoliao.com/tag/%e8%ae%a1%e7%ae%97/" title="计算">计算</a>, <a href="https://www.biecuoliao.com/tag/timeout/" title="timeout">timeout</a>, <a href="https://www.biecuoliao.com/tag/dbi/" title="dbi">dbi</a>, <a href="https://www.biecuoliao.com/tag/vpx/" title="vpx">vpx</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>zookeeper原理解析-数据存储的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3vZ97R3.html" rel="bookmark">2&period;zookeeper原理解析-数据存储之Snapshot</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				=====================================斩秋|http://blog.csdn.net/quhongwei_zhanqiu======================================= Snapshot是datatree在内存中某一时刻的影像,zookeeper有一定的机制会定时生成datatree的snapshot.FileSnap实现了SnapShot接口负责将数据写入文件中,下面我们来看看snap相关内容. 2.1 snapshot文件格式			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/ME8bVP4.html" rel="bookmark">3&period;zookeeper原理解析-数据存储之TxnLog事务日志</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				=====================================斩秋|http://blog.csdn.net/quhongwei_zhanqiu======================================= 事务日志文件用来记录事物操作,每一个事务操作如添加,删除节点等等,都会在事务日志中记录一条记录,用来在zookeeper异常情况下,通过txnlog和snapshot文件来恢复数据,下面我们来看下txnLog事务日志文件的格式 打开一个事务日志文件看看 一个日志文			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4JkWvVM.html" rel="bookmark">解析数据存储MySQL</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				为了适应不同项目对不同感兴趣属性的解析存储,数据存储结构采用纵向的属性列表方式,即一个url页面多个属性存储多条记录方式,并且按照text,html,data,num几大典型类型分别对应存储. 创建UTF-8字符集的nutch数据库,并执行表初始化脚本,参考DDL: CREATE TABLE `crawl_data` ( `url` varchar(255) NOT NULL, `code` varchar(255) NOT NULL, `name` varchar(255) DEFAULT N			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0l1xZE3.html" rel="bookmark">zookeeper原理解析-选举</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1)QuorumPeerMain加载 Zookeeper集群启动的入口类是QuorumPeerMain来加载配置启动QuorumPeer线程.首先我们来看下QuorumPeer, 谷歌翻译quorum是法定人数,定额的意思, peer是对等的意思,那么QuorumPeer中quorum代表的意思就是每个zookeeper集群启动的时候集群中zookeeper服务数量就已经确定了,在每个zookeeper的配置文件中配置集群中的所有机器 server.1=127.0.0.1:2886:3886 s			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MX9lWa0.html" rel="bookmark">Zookeeper原理分析之存储结构Snapshot</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Zookeeper内存结构 Zookeeper数据在内存中的结构类似于linux的目录结构,DataTree代表这个目录结构, DataNode代表一个节点.DataTree默认初始化三个目录:&quot;&quot;,&quot;/zookeeper&quot;,&quot;/zookeeper/quota&quot; DataNode表示一个节点,存储了一下信息: 父节点的引用 节点的权限集合 子节点路径集合 Snapshot Snapshot是datatree在内存中某一时刻的快照,zookeepe			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3ZVOPJ3.html" rel="bookmark">15&period;zookeeper原理解析-服务器端处理流程之交互图</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				===================斩秋|http://blog.csdn.net/quhongwei_zhanqiu=============== Zookeeper集群中server数量总是确定的,所以集群中的server交互采用比较可靠的bio长连接模型:不同于集群中sever间交互zookeeper客户端其实数量是未知的,为了提高zookeeper并发性能,zookeeper客户端与服务器端交互采用nio模型.下面我们主要来讲讲zookeeper的服务器端与客户端的交互.读者对nio不			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/412EyOM.html" rel="bookmark">13&period;zookeeper原理解析-服务器端处理流程之处理器详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				===================斩秋|http://blog.csdn.net/quhongwei_zhanqiu=============== 各个processor的主要功能 1) PrepRequestProcessor 如名字这个处理器主要功能是对请求进行预处理, 将client向server请求二进制数据反序列化成sever中请求操作. PrepRequestProcessor做为leader的第一个处理器,它的请求数据来源主要来自: (1)    Leader做一个zk服务接收			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xaqyN3.html" rel="bookmark">zookeeper原理解析-服务器端处理流程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1)处理器链 这部分内容我们主要讲解zookeeper请求在zookeeper server端的处理流程,对于不同角色的zookeeper具有不同的处理流程, ZookeepeerServer的start方法中会调用setupRequestProcessors()来初始化处理器链,它被子类覆写实现. 1.      LeaderZooKeeperServer 看如上代码主要建立了如下的两个处理器流链 (1)    PrepRequestProcessor(线程) =&gt; ProposalReque			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MzEgW24.html" rel="bookmark">zookeeper原理解析-客户端与服务器端交互</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Zookeeper集群中server数量总是确定的,所以集群中的server交互采用比较可靠的bio长连接模型:不同于集群中sever间交互zookeeper客户端其实数量是未知的,为了提高zookeeper并发性能,zookeeper客户端与服务器端交互采用nio模型.下面我们主要来讲讲zookeeper的服务器端与客户端的交互.读者对nio不了解的话不妨抽点时间去了解下,对于一些nio框架如netty,mina再如一些web容器如tomcat,jetty底层都实现一套nio框架,对于实现ni			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lXWNB0.html" rel="bookmark" class="title">Centos6&period;4 安装fail2ban防暴力破解</a>
					<div>
						Centos6.4 安装fail2ban防暴力破解 一. 安装 curl -O https://codeload.github.com/fail2ban/fail2ban/tar.gz/0.9.0 m ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0eA6jv0.html" rel="bookmark" class="title">Android中Fragment和Activity之间的互操作代码例子</a>
					<div>
						摘要 本文介绍了Android中一个Activity中有多个Fragment的情况下,Fragment之间如何通过Activity进行互操作. 源代码 源代码地址为:http://download.c ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vEwko0.html" rel="bookmark" class="title">PHP内核探索之变量（3）- hash table</a>
					<div>
						在PHP中,除了zval, 另一个比较重要的数据结构非hash table莫属,例如我们最常见的数组,在底层便是hash table.除了数组,在线程安全(TSRM).GC.资源管理.Global变量 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dg18zM.html" rel="bookmark" class="title">oracle ref游标</a>
					<div>
						Oracle 系列:REF Cursor 在上文  Oracle 系列:Cursor  (参见:http://blog.csdn.net/qfs_v/archive/2008/05/06/240479 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoQPXx3.html" rel="bookmark" class="title">zabbix修改Template OS Linux模版使已使用内存&lpar;Used memory&rpar;更准确</a>
					<div>
						可用内存:Available memory=free+buffers+cached,即2021=235+394+1392已使用内存:Used memory=used-buffers-cached,即3 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0d5pKr3.html" rel="bookmark" class="title">在hadoop运行tensor flow</a>
					<div>
						http://www.infoq.com/cn/articles/deeplearning-tensorflow-casestudy http://www.tuicool.com/articles/a ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RGoXy3.html" rel="bookmark" class="title">nova-manage service list函数调用过程</a>
					<div>
						这里都是通过pdb调试的,pdb教程见这里:http://iceyao.blog.51cto.com/9426658/1599320 # 先从nova-manage这个程序开始 [[email pro ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kZGvpM.html" rel="bookmark" class="title">Android开发系列（二十三）：实现带图片提示的Toast提示信息框</a>
					<div>
						Android中的Toast是很常见的一个消息提示框,但是默认的消息提示框就是一行纯文本,所以我们可以为它设置一些其他的诸如是带上图片的消息提示. 实现这个很简单: 就是定义一个Layout视图,然后 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ODyl84.html" rel="bookmark" class="title">android开发权威指南读书笔记</a>
					<div>
						第17章 Fragment 1.在res目录下增加 layout-sw600dp 目录,用于存放7英寸及以上尺寸屏幕的布局文件.10英寸以上平板用 sw720dp.如果是更小的屏幕,如 480*800 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qx8ZP0.html" rel="bookmark" class="title">计算机程序的思维逻辑 &lpar;7&rpar; - 如何从乱码中恢复 &lpar;下&rpar;</a>
					<div>
						乱码 上节说到乱码出现的主要原因,即在进行编码转换的时候,如果将原来的编码识别错了,并进行了转换,就会发生乱码,而且这时候无论怎么切换查看编码的方式,都是不行的. 我们来看一个这种错误转换后的乱码,还 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLZLje3.html" rel="bookmark" class="title">【bzoj2007】&lbrack;Noi2010&rsqb;海拔  最小割&plus;对偶图&plus;最短路</a>
					<div>
						题目描述 YT市是一个规划良好的城市,城市被东西向和南北向的主干道划分为n×n个区域.简单起见,可以将YT市看作一个正方形,每一个区域也可看作一个正方形.从而,YT城市中包括(n+1)×(n+1)个交 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xZPa74.html" rel="bookmark" class="title">python实现不可修改的常量</a>
					<div>
						因为种种原因,Python并未提供如C/C++/Java一样的const修饰符,换言之,python中没有常量,至少截止2015年年末,还没有这个打算.Python程序一般通过约定俗成的变量名全大写的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rbO9b3.html" rel="bookmark" class="title">PowerDesigner数据建模工具</a>
					<div>
						目标:本文主要介绍PowerDesigner中概念数据模型 CDM的基本概念. 一.概念数据模型概述数据模型是现实世界中数据特征的抽象.数据模型应该满足三个方面的要求:1)能够比较真实地模拟现实世界2 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qGao5M.html" rel="bookmark" class="title">华为荣耀平板s8-701w刷机记</a>
					<div>
						稀里糊涂地,不知何时,平板的系统被我搞成3G版的,遇到各种问题,充电慢.用电快.卡死.界面逼死人,想找回原来的系统,结果发现,出厂重置还是同样的系统,机内刷ROM点击本地升级没反应,刷机软件又都不支持 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38yzAy4.html" rel="bookmark" class="title">数据结构与算法分析java&mdash;&mdash;树</a>
					<div>
						1. 基本术语 度(degree):一个节点的子树个数称为该节点的度: 树中结点度的最大值称为该树的度. 层数(level):从根结点开始算,根节点为1 高度(height)/深度(depth):节点 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vAVdk0.html" rel="bookmark" class="title">JavaScript异步编程&lowbar;&lowbar;&OpenCurlyDoubleQuote;回调地狱&rdquo;的一些解决方案</a>
					<div>
						异步编程在JavaScript中非常重要.过多的异步编程也带了回调嵌套的问题,本文会提供一些解决&quot;回调地狱&quot;的方法. setTimeout(function () { consol ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/472pWk3.html" rel="bookmark" class="title">微信小程序通过api接口将json数据展现到小程序示例</a>
					<div>
						实现知乎客户端的一个重要知识前提就是,要知道怎么通过知乎新闻的接口,来把数据展示到微信小程序端上. 那么我们这一就先学习一下,如何将接口获取到的数据展示到微信小程序上. 1.用到的知识点 &lt;1& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0l89do0.html" rel="bookmark" class="title">likely&comma; unlikely的作用</a>
					<div>
						在项目中看到了likely.unlikely宏的使用, 一直不是非常清楚它们的作用,所以就深究下. likely表示被測试的表达式大多数情况下为true, unlikely则表示相反. 两个宏定义:  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVK8by0.html" rel="bookmark" class="title">STL中的各种排序函数</a>
					<div>
						标准c++库中提供六种排序方法:qsort(),  sort(),stable_sort(),  partial_sort(),  list::sort(),  set/multiset qsort( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rOa8X4.html" rel="bookmark" class="title">用 16G 内存存放 30亿数据（Java Map）转载</a>
					<div>
						在讨论怎么去重,提出用 direct buffer 建 btree,想到应该有现成方案,于是找到一个好东西: MapDB - MapDB : http://www.mapdb.org/ 以下来自:ko ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.027 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
